{% macro subscribe_button(forum, subscribed, inline) %}
  {%- set subscriber_count = subscriber_count ?? forum.subscriptions|length -%}
  {%- from '_macros/icon.html.twig' import icon -%}
  {%- from _self import subscribe_button, _subscribe_button_inner -%}
  <button class="button {{ inline ? 'button--small inline' }} subscribe-button subscribe-button--{{ subscribed ? 'un' }}subscribe"
          data-toggle-prototype="{{ _subscribe_button_inner(not subscribed, subscriber_count + (subscribed ? -1 : 1))|e }}">
    {{- _subscribe_button_inner(subscribed, subscriber_count) -}}
  </button>
{%- endmacro %}

{% macro _subscribe_button_inner(subscribed, subscriber_count) %}
  <span class="subscribe-button__inner">
    <span class="subscribe-button__label">
      {{ (subscribed ? 'forum.unsubscribe' : 'forum.subscribe')|trans }}

      {# dummy label to keep width consistent regardless of subscription state #}
      <span class="subscribe-button__dummy-label" aria-hidden="true">
        {{ (subscribed ? 'forum.subscribe' : 'forum.unsubscribe')|trans }}
      </span>
    </span>

    <span class="subscribe-button__subscriber-count"
          aria-label="{{ 'forum.subscriber_count'|trans({
            '%count%': subscriber_count,
            '%formatted_count%': subscriber_count|localizednumber,
          }) }}">
      {{- subscriber_count|localizednumber -}}
    </span>
  </span>
{% endmacro %}

{%- macro log_line(entry) -%}
  {%- from _self import _log_submission_deletion as submission_deletion,
                        _log_submission_lock as submission_lock,
                        _log_comment_deletion as comment_deletion,
                        _log_ban as ban -%}
  {%- if entry.action == 'comment_deletion' -%}
    {{- comment_deletion(entry) -}}
  {%- elseif entry.action == 'submission_deletion' -%}
    {{- submission_deletion(entry) -}}
  {%- elseif entry.action == 'submission_lock' -%}
    {{- submission_lock(entry) -}}
  {%- elseif entry.action == 'ban' -%}
    {{- ban(entry) -}}
  {%- endif -%}
{%- endmacro -%}

{% macro _log_comment_deletion(entry) %}
  {% from 'user/_macros.html.twig' import user_link %}
  {{ 'log.comment_deletion'|trans({
    '%user%': user_link(entry.user, {flag: entry.wasAdmin ? 'admin' : 'moderator'}),
    '%author%': user_link(entry.author),
    '%submission%': entry.submission
    ? '<a href="%s">%s</a>'|format(
      path('submission', {forum_name: entry.submission.forum.name, submission_id: entry.submission.id})|e,
      entry.submission.title|e
    ) : '<del>%s</del>'|format(entry.title|e),
  })|raw }}
{% endmacro %}

{% macro _log_submission_deletion(entry) %}
  {% from 'user/_macros.html.twig' import user_link %}
  {{ (entry.reason is null ? 'log.submission_deletion' : 'log.submission_deletion_with_reason')|trans({
    '%user%': user_link(entry.user, {flag: entry.wasAdmin ? 'admin' : 'moderator'}),
    '%author%': user_link(entry.author),
    '%title%': '<del>%s</del>'|format(entry.title|e),
    '%reason%': entry.reason,
  })|raw }}
{% endmacro %}

{% macro _log_submission_lock(entry) %}
  {% from 'user/_macros.html.twig' import user_link %}
  {{ (entry.locked ? 'log.submission_lock' : 'log.submission_unlock')|trans({
    '%user%': user_link(entry.user, {flag: entry.wasAdmin ? 'admin' : 'moderator'}),
    '%author%': user_link(entry.author),
    '%title%': entry.submission ? entry.submission.title|e : '<del>%s</del>'|format(entry.title|e)
  })|raw }}
{% endmacro %}

{% macro _log_ban(entry) %}
  {% from 'user/_macros.html.twig' import user_link %}
  {% from '_macros/time.html.twig' import relative_time_diff %}
  {% if entry.ban.ban %}
    {% if entry.ban.expired %}<del>{% endif %}
    {{ 'log.ban'|trans({
      '%user%': user_link(entry.user, {flag: entry.wasAdmin ? 'admin' : 'moderator'}),
      '%banned%': user_link(entry.ban.user),
      '%expires%': entry.ban.expiryTime ? relative_time_diff(entry.ban.expiryTime, entry.ban.timestamp) : 'label.never'|trans,
      '%reason%': entry.ban.reason|e,
    })|raw }}
    {% if entry.ban.expired %}</del>{% endif %}
  {% else %}
    {{ 'log.unban'|trans({
      '%user%': user_link(entry.user, {flag: entry.wasAdmin ? 'admin' : 'moderator'}),
      '%banned%': user_link(entry.ban.user),
      '%reason%': entry.ban.reason|e,
    })|raw }}
  {% endif %}
{% endmacro %}
